/* vim:set ft=cpp ts=4 sw=4 sts=4 sta ai bs=2: */
// MoinManagerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MoinManager.h"
#include "MoinManagerDlg.h"
#include "./Utils/DirBrowser.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define UWM_SYSTRAY		(WM_APP + 1)


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMoinManagerDlg dialog

CMoinManagerDlg::CMoinManagerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMoinManagerDlg::IDD, pParent)
	, m_bStartServerWhenExecute(false)
{
	//{{AFX_DATA_INIT(CMoinManagerDlg)
	m_strPythonPath = _T("");
	m_strMoinPath = _T("");
	m_bStartAppWhenBoot = FALSE;
	m_bTrayWhenStart = FALSE;
	m_bTrayWhenMinimize = FALSE;
	m_bDosWinWhenStart = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bStartedServer = FALSE;
	m_hPython = 0;
}

void CMoinManagerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMoinManagerDlg)
	DDX_Text(pDX, IDC_PYTHON_PATH, m_strPythonPath);
	DDX_Text(pDX, IDC_MOIN_PATH, m_strMoinPath);
	DDX_Check(pDX, IDC_EN_STARTAPP_WHEN_BOOT, m_bStartAppWhenBoot);
	DDX_Check(pDX, IDC_EN_STARTSERVER_WHEN_EXECUTE, m_bStartServerWhenExecute);
	DDX_Check(pDX, IDC_EN_TRAY_WHEN_START, m_bTrayWhenStart);
	DDX_Check(pDX, IDC_EN_TRAY_WHEN_MINIMIZE, m_bTrayWhenMinimize);
	DDX_Check(pDX, IDC_EN_DOSWIN_WHEN_START, m_bDosWinWhenStart);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMoinManagerDlg, CDialog)
	//{{AFX_MSG_MAP(CMoinManagerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_CHANGE(IDC_MOIN_PATH, OnChangeMoinPath)
	ON_EN_CHANGE(IDC_PYTHON_PATH, OnChangePythonPath)
	ON_BN_CLICKED(IDC_EN_DOSWIN_WHEN_START, OnEnDoswinWhenStart)
	ON_BN_CLICKED(IDC_EN_STARTAPP_WHEN_BOOT, OnEnStartAppWhenBoot)
	ON_BN_CLICKED(IDC_EN_TRAY_WHEN_MINIMIZE, OnEnTrayWhenMinimize)
	ON_BN_CLICKED(IDC_EN_TRAY_WHEN_START, OnEnTrayWhenStart)
	ON_BN_CLICKED(IDC_START_SERVER, OnStartServer)
	ON_BN_CLICKED(IDC_STOP_SERVER, OnStopServer)
	ON_BN_CLICKED(IDC_SEL_PYTHON_PATH, OnSelPythonPath)
	ON_BN_CLICKED(IDC_SEL_MOIN_PATH, OnSelMoinPath)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	ON_MESSAGE(UWM_SYSTRAY, OnTrayNotify)
	ON_COMMAND(IDM_RESTOREWND, &CMoinManagerDlg::OnRestorewnd)
	ON_COMMAND(IDM_STARTSERVER, &CMoinManagerDlg::OnStartserver)
	ON_COMMAND(IDM_STOPSERVER, &CMoinManagerDlg::OnStopserver)
	ON_COMMAND(IDM_ABOUT, &CMoinManagerDlg::OnAbout)
	ON_COMMAND(IDM_SYSEXIT, &CMoinManagerDlg::OnSysexit)
	ON_BN_CLICKED(IDC_EN_STARTSERVER_WHEN_EXECUTE, &CMoinManagerDlg::OnBnClickedEnStartserverWhenExecute)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMoinManagerDlg message handlers

BOOL CMoinManagerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_SysTray.Create( this, UWM_SYSTRAY, _T("MoinManager"),
		AfxGetApp()->LoadIcon(IDR_MAINFRAME), IDM_SYSTRAY, FALSE);

	LoadCfgFile();
	UpdateControl();


	if( m_bTrayWhenStart) {
		m_SysTray.MinimiseToTray(this);
	}

	if( m_bStartServerWhenExecute) {
		OnStartServer();
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMoinManagerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		if( nID == SC_MINIMIZE && m_bTrayWhenMinimize) {
				m_SysTray.MinimiseToTray(this);
		}
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMoinManagerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMoinManagerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CMoinManagerDlg::LoadCfgFile(void)
{
	m_strPythonPath = m_CfgFile.GetString( _T("APP"), _T("PYTHON PATH"), _T(""));
	m_strMoinPath = m_CfgFile.GetString( _T("APP"), _T("MOIN PATH"), _T(""));

	m_bStartAppWhenBoot = m_CfgFile.GetBool( _T("APP"), _T("STARTAPP WHEN BOOT"), TRUE);
	m_bStartServerWhenExecute = m_CfgFile.GetBool( _T("APP"), _T("STARTSERVER WHEN EXECUTE"), TRUE);
	m_bTrayWhenStart = m_CfgFile.GetBool( _T("APP"), _T("TRAY WHEN START"), FALSE);
	m_bTrayWhenMinimize = m_CfgFile.GetBool( _T("APP"), _T("TRAY WHEN MINIMIZE"), TRUE);
	m_bDosWinWhenStart = m_CfgFile.GetBool( _T("APP"), _T("DOSWIN WHEN START"), FALSE);

	UpdateData( FALSE);
}


void CMoinManagerDlg::SaveCfgFile(void)
{
	UpdateData( TRUE);

	m_CfgFile.WriteString( _T("APP"), _T("PYTHON PATH"), m_strPythonPath);
	m_CfgFile.WriteString( _T("APP"), _T("MOIN PATH"), m_strMoinPath);

	m_CfgFile.WriteBool( _T("APP"), _T("STARTAPP WHEN BOOT"), m_bStartAppWhenBoot);
	m_CfgFile.WriteBool( _T("APP"), _T("STARTSERVER WHEN EXECUTE"), m_bStartServerWhenExecute);
	m_CfgFile.WriteBool( _T("APP"), _T("TRAY WHEN START"), m_bTrayWhenStart);
	m_CfgFile.WriteBool( _T("APP"), _T("TRAY WHEN MINIMIZE"), m_bTrayWhenMinimize);
	m_CfgFile.WriteBool( _T("APP"), _T("DOSWIN WHEN START"), m_bDosWinWhenStart);
}

void CMoinManagerDlg::OnChangeMoinPath() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	SaveCfgFile();
}

void CMoinManagerDlg::OnChangePythonPath() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	SaveCfgFile();
}

void CMoinManagerDlg::OnEnDoswinWhenStart() 
{
	// TODO: Add your control notification handler code here
	SaveCfgFile();
}

void CMoinManagerDlg::OnEnStartAppWhenBoot() 
{
	// TODO: Add your control notification handler code here
	SaveCfgFile();
}

void CMoinManagerDlg::OnBnClickedEnStartserverWhenExecute()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	SaveCfgFile();
}

void CMoinManagerDlg::OnEnTrayWhenMinimize() 
{
	// TODO: Add your control notification handler code here
	SaveCfgFile();
}

void CMoinManagerDlg::OnEnTrayWhenStart() 
{
	// TODO: Add your control notification handler code here
	SaveCfgFile();
}


void CMoinManagerDlg::UpdateControl(void)
{
	GetDlgItem( IDC_START_SERVER)->EnableWindow( !m_bStartedServer);
	GetDlgItem( IDC_STOP_SERVER)->EnableWindow( m_bStartedServer);

	GetDlgItem( IDC_SEL_PYTHON_PATH)->EnableWindow( !m_bStartedServer);
	GetDlgItem( IDC_SEL_MOIN_PATH)->EnableWindow( !m_bStartedServer);

	GetDlgItem( IDC_EN_DOSWIN_WHEN_START)->EnableWindow( !m_bStartedServer);
}

BOOL CMoinManagerDlg::CheckPath(void)
{
	CString fname;
	fname.Format( _T("%s\\python.exe"), m_strPythonPath);
	
	if( _taccess( fname, 0x00) != 0) {
		CString msg;
		msg.Format( _T("%s   ʽϴ."), fname);
		AfxMessageBox( msg);
		return FALSE;
	}

	fname.Format( _T("%s\\moin.py"), m_strMoinPath);
	if( _taccess( fname, 0x00) != 0) {
		CString msg;
		msg.Format( _T("%s   ʽϴ."), fname);
		AfxMessageBox( msg);
		return FALSE;
	}

	return TRUE;
}

void CMoinManagerDlg::OnStartServer() 
{
	// TODO: Add your control notification handler code here

	if( CheckPath() == FALSE) {
		return;
	}

	CString cmdline;
	cmdline.Format( _T("%s\\python.exe %s\\moin.py"), m_strPythonPath, m_strMoinPath);
	

	BOOL bRet;

	STARTUPINFO StartupInfo = {0};
	PROCESS_INFORMATION ProcessInfo;

	StartupInfo.cb = sizeof(STARTUPINFO);

	memset( &ProcessInfo, 0, sizeof(PROCESS_INFORMATION));

	bRet = ::CreateProcess(
			NULL,
			(LPTSTR)(LPCTSTR)cmdline,
			NULL,
			NULL,
			FALSE,
			m_bDosWinWhenStart ? 0 : CREATE_NO_WINDOW,
			NULL,
			NULL,
			&StartupInfo,
			&ProcessInfo);

	if( bRet == 0) {
		AfxMessageBox( _T("μ   ϴ."));
		m_hPython = 0;
		return;
	}
	
	m_hPython = ProcessInfo.hProcess;
	m_bStartedServer = TRUE;
	UpdateControl();
}

void CMoinManagerDlg::OnStopServer() 
{
	// TODO: Add your control notification handler code here
	if( m_hPython != 0) {
		::TerminateProcess( m_hPython, 0);
		Sleep(1 * 1000);
	}
	
	m_hPython = 0;
	
	m_bStartedServer = FALSE;
	UpdateControl();
}

void CMoinManagerDlg::OnSelPythonPath() 
{
	// TODO: Add your control notification handler code here
	LPCTSTR lpPath;
	lpPath = GetDirectory( this->GetSafeHwnd(), NULL, _T("̽ 丮  ּ!"));
	if( lpPath != NULL) {
		m_strPythonPath = lpPath;
		UpdateData(FALSE);
		SaveCfgFile();
	}
}

void CMoinManagerDlg::OnSelMoinPath() 
{
	// TODO: Add your control notification handler code here

	LPCTSTR lpPath;
	lpPath = GetDirectory( this->GetSafeHwnd(), NULL, _T("θ 丮  ּ!"));
	if( lpPath != NULL) {
		m_strMoinPath = lpPath;
		UpdateData(FALSE);
		SaveCfgFile();
	}
}

void CMoinManagerDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	if( m_bStartedServer) {
		OnStopServer();
	}
	CDialog::OnClose();
}


LRESULT CMoinManagerDlg::OnTrayNotify(WPARAM wParam, LPARAM lParam)
{
	if( lParam == WM_RBUTTONUP) {
		CMenu menu, *pMenu;
		CPoint pt;

		menu.LoadMenu( IDM_SYSTRAY);
		pMenu = menu.GetSubMenu(0);

		GetCursorPos(&pt);

		SetForegroundWindow();
		UINT uMenuID = pMenu->TrackPopupMenu( TPM_LEFTALIGN | TPM_LEFTBUTTON,
				pt.x, pt.y, this);
		SetForegroundWindow();

		::PostMessage( m_hWnd, WM_NULL, 0, 0);

		pMenu->DestroyMenu();
		menu.DestroyMenu();
	} else if( lParam == WM_LBUTTONDBLCLK) {
		m_SysTray.MaximiseFromTray(this);
	}

	return 0;
}

void CMoinManagerDlg::OnRestorewnd()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	m_SysTray.MaximiseFromTray(this);
}

void CMoinManagerDlg::OnStartserver()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	OnStartServer();
}

void CMoinManagerDlg::OnStopserver()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	OnStopServer();
}

void CMoinManagerDlg::OnAbout()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

void CMoinManagerDlg::OnSysexit()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	PostQuitMessage(0);
}
