/* vim:set ft=cpp ts=4 sw=4 sts=4 sta ai bs=2: */
// MoinManagerDlg.h : header file
//

#if !defined(AFX_MOINMANAGERDLG_H__DDBB1264_5AD6_4F10_8C7D_463C84DB156C__INCLUDED_)
#define AFX_MOINMANAGERDLG_H__DDBB1264_5AD6_4F10_8C7D_463C84DB156C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "./Utils/CfgFile.h"
#include "./Utils/SystemTray.h"

/////////////////////////////////////////////////////////////////////////////
// CMoinManagerDlg dialog

class CMoinManagerDlg : public CDialog
{
// Construction
public:
	CMoinManagerDlg(CWnd* pParent = NULL);	// standard constructor
	
	CSystemTray m_SysTray;

// Dialog Data
	//{{AFX_DATA(CMoinManagerDlg)
	enum { IDD = IDD_MOINMANAGER_DIALOG };
	CString	m_strPythonPath;
	CString	m_strMoinPath;
	BOOL	m_bStartAppWhenBoot;
	BOOL	m_bTrayWhenStart;
	BOOL	m_bTrayWhenMinimize;
	BOOL	m_bDosWinWhenStart;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMoinManagerDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HANDLE m_hPython;

	CCfgFile m_CfgFile;
	void LoadCfgFile(void);
	void SaveCfgFile(void);

	BOOL m_bStartedServer;
	void UpdateControl(void);

	BOOL CheckPath(void);
	
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CMoinManagerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnChangeMoinPath();
	afx_msg void OnChangePythonPath();
	afx_msg void OnEnDoswinWhenStart();
	afx_msg void OnEnStartAppWhenBoot();
	afx_msg void OnEnTrayWhenMinimize();
	afx_msg void OnEnTrayWhenStart();
	afx_msg void OnStartServer();
	afx_msg void OnStopServer();
	afx_msg void OnSelPythonPath();
	afx_msg void OnSelMoinPath();
	afx_msg void OnClose();
	//}}AFX_MSG
	afx_msg LRESULT OnTrayNotify(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnRestorewnd();
public:
	afx_msg void OnStartserver();
public:
	afx_msg void OnStopserver();
public:
	afx_msg void OnAbout();
public:
	afx_msg void OnSysexit();
public:
	afx_msg void OnBnClickedEnStartserverWhenExecute();
	BOOL	m_bStartServerWhenExecute;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MOINMANAGERDLG_H__DDBB1264_5AD6_4F10_8C7D_463C84DB156C__INCLUDED_)
