/*! \class CCfgFile
 * \brief Application ȯ漳ϵ Loadϰ Saveϴ Ŭ.
 * \author KTD of UNIMO.CO.KR
 * \version 0.1.004
 * \date 20051102
 *
 * 
 *	-# νϽ.
 *		\code
 *		CCfgFile m_CfgFile;
 *		CCfgFile* m_pCon = new CCfgFile( _T("c:\\temp\\a.ini"));
 *		\endcode
 *	-# filename, directory[optional]
 *		\code
 *		m_CfgFile.SetFilePath( _T("c:\\temp\\ktd.ini"));
 *		m_CfgFile.SetFileDir( _T("c:"));		// ڿ '\\' ٿ ǰ Ⱥٿ.
 *		m_CfgFile.SetFilename( _T("ktd.ini"));	// ϸ .
 *		m_CfgFile.SetEnvDir( _T("TEMP"));		// ȯ溯丮 .
 *		\endcode
 *	-# ȯ漳Ͽ Loadϰ Saveϱ.
 *		\code
 *		// ڿ Loadϰ Saveϴ Լ.
 *		m_ConfigFile.WritePrivateProfileString( _T("SECTION"), _T("NAME"), _T("VALUE"));
 *		m_ConfigFile.GetPrivateProfileString( _T("SECTION"), _T("NAME"), _T("DefValue"), DesBuffer, nSize);
 *
 *		//  Loadϰ Saveϴ Լ.
 *		m_ConfigFile.WritePrivateProfileInt( _T("SECTION"), _T("NAME"), nValue);
 *		nRetValue = m_ConfigFile.GetPrivateProfileInt( _T("SECTION"), _T("NAME"), nDefValue);
 *
 *		// Ǽ Loadϰ Saveϴ Լ.
 *		m_ConfigFile.WritePrivateProfileDouble( _T("SECTION"), _T("NAME"), fValue);
 *		fRetValue = m_ConfigFile.GetPrivateProfileDouble( _T("SECTION"), _T("NAME"), fDefValue);
 *
 *		// BOOL Loadϰ Saveϴ Լ.
 *		m_ConfigFile.WritePrivateProfileBool( _T("SECTION"), _T("NAME"), bValue);
 *		bRetValue = m_ConfigFile.GetPrivateProfileBool( _T("SECTION"), _T("NAME"), bDefValue);
 *
 *		// IPAddress Loadϰ Saveϴ Լ.
 *		m_ConfigFile.WritePrivateProfileIpAddress( _T("IP ADDRESS"), _T("IP ADDRESS"), &ctlIpAddress);
 *		m_ConfigFile.GetPrivateProfileIpAddress( _T("IP ADDRESS"), _T("IP ADDRESS"), &ctlIpAddress, _T("0.0.0.0"));
 *		\endcode
 *
 * \warning
 * Ʈ ȯ漳 δ  .\n
 * Ʈ ȯ漳 Ȯڴ ini.
 */

#if !defined(AFX_CFGFILE_H__8DB0FD51_61E5_11D6_80A9_000476D2B6CA__INCLUDED_)
#define AFX_CFGFILE_H__8DB0FD51_61E5_11D6_80A9_000476D2B6CA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CfgFile.h : header file
//


//! _access Լ  ϱ  include.
#include <io.h>


/////////////////////////////////////////////////////////////////////////////
// CCfgFile command target

class CCfgFile : public CObject
{
	// Attributes
public:


	// Operations
public:
	//! .
	CCfgFile( LPCTSTR lpszFilePath = NULL);

	//! Ҹ.
	virtual ~CCfgFile();


	//! File FullPath Setϴ Լ.
	BOOL SetFilePath( LPCTSTR lpFilePath);

	//! File FullPath Getϴ Լ.
	LPCTSTR GetFilePath() const { return m_szFilePath;}


	//! File 丮 Setϴ Լ.
	BOOL SetFileDir( LPCTSTR szFileDir)
	{
		//  ־ ΰ   FALSE ȯ.
		if( _taccess( szFileDir, 0) != 0)
			return FALSE;

		m_szFileDir = szFileDir;

		// θ m_szFileDir  ݵ '\\'  ־ Ѵ.
		//  '\\' ٸ ٿش.
		if( m_szFileDir[ m_szFileDir.GetLength() - 1] != '\\')
		{
			// 丮 P '\\'   '\\' δ.
			m_szFileDir += '\\';
		}

		m_szFileDir.MakeLower();

		m_szFilePath = m_szFileDir + m_szFileName;

		return TRUE;
	}

	//! File 丮 Getϴ Լ.
	LPCTSTR GetFileDir() const { return m_szFileDir;}


	//! FileName Setϴ Լ.
	void SetFileName( LPCTSTR szFileName)
	{
		m_szFileName = szFileName;
		m_szFileName.MakeLower();
		m_szFilePath = m_szFileDir + m_szFileName;
	}

	//! FileName Getϴ Լ.
	LPCTSTR GetFileName() const { return m_szFileName;}


	//! ȯ溯 丮 ϰθ ϴ Լ.
	BOOL SetEnvDir( LPCTSTR szEnv);


	//!   丮 ϴ ȯϴ Լ.
	BOOL IsExistDir() const
	{
		return !(_taccess( m_szFileDir, 0));
	}


	//!   FullPath(Path+Name) ϴ ȯϴ Լ.
	BOOL IsExistFilePath() const
	{
		return !(_taccess( m_szFilePath, 0));
	}

	//!   Getϴ Լ.
	UINT GetInt(
		LPCTSTR lpAppName,			// section name
		LPCTSTR lpKeyName,			// key name
		INT		nDefault			// return value if key name not found
		) const {
		return GetPrivateProfileInt( lpAppName, lpKeyName, nDefault);
	};

	//!   Getϴ Լ.
	UINT GetPrivateProfileInt(
		LPCTSTR lpAppName,			// section name
		LPCTSTR lpKeyName,			// key name
		INT		nDefault			// return value if key name not found
		) const;

	//!   Writeϴ Լ.
	BOOL WriteInt( 
		LPCTSTR lpAppName,			// section name
		LPCTSTR lpKeyName,			// key name
		INT nValue					// value
		) const {
		return WritePrivateProfileInt( lpAppName, lpKeyName, nValue);
	};

	//!   Writeϴ Լ.
	BOOL WritePrivateProfileInt(
		LPCTSTR lpAppName,			// section name
		LPCTSTR lpKeyName,			// key name
		INT nValue					// value
		) const;

	//! Ǽ  Getϴ Լ.
	DOUBLE GetDouble(
		LPCTSTR lpAppName,			// section name
		LPCTSTR lpKeyName,			// key name
		DOUBLE	fDefault			// return value if key name not found
		) const {
		return GetPrivateProfileDouble( lpAppName, lpKeyName, fDefault);
	};

	//! Ǽ  Getϴ Լ.
	DOUBLE GetPrivateProfileDouble(
		LPCTSTR lpAppName,			// section name
		LPCTSTR lpKeyName,			// key name
		DOUBLE	fDefault			// return value if key name not found
		) const;

	//! Ǽ  Writeϴ Լ.
	BOOL WriteDouble(
		LPCTSTR lpAppName,			// section name
		LPCTSTR lpKeyName,			// key name
		double fValue				// value
		) const {
		return WritePrivateProfileDouble( lpAppName, lpKeyName, fValue);
	};

	//! Ǽ  Writeϴ Լ.
	BOOL WritePrivateProfileDouble(
		LPCTSTR lpAppName,			// section name
		LPCTSTR lpKeyName,			// key name
		double fValue				// value
		) const;

	//! BOOL  Getϴ Լ.
	BOOL GetBool(
		LPCTSTR lpAppName,			// section name
		LPCTSTR lpKeyName,			// key name
		BOOL	bDefault			// return value if key name not found
		) const {
		return GetPrivateProfileBool( lpAppName, lpKeyName, bDefault);
	};

	//! BOOL  Getϴ Լ.
	BOOL GetPrivateProfileBool(
		LPCTSTR lpAppName,			// section name
		LPCTSTR lpKeyName,			// key name
		BOOL	bDefault			// return value if key name not found
		) const;

	//! BOOL  Writeϴ Լ.
	BOOL WriteBool(
		LPCTSTR	lpAppName,			// section name
		LPCTSTR	lpKeyName,			// key name
		BOOL	bValue				// value
		) const {
		return WritePrivateProfileBool( lpAppName, lpKeyName, bValue);
	};

	//! BOOL  Writeϴ Լ.
	BOOL WritePrivateProfileBool(
		LPCTSTR	lpAppName,			// section name
		LPCTSTR	lpKeyName,			// key name
		BOOL	bValue				// value
		) const;

	//! ڿ  Getϴ Լ.
	DWORD GetString(
		LPCTSTR lpAppName,			// section name
		LPCTSTR lpKeyName,			// key name
		LPCTSTR lpDefault,			// default string
		LPTSTR	lpReturnedString,	// destination buffer
		DWORD	nSize				// size of destination buffer
		) const {
		return GetPrivateProfileString( lpAppName, lpKeyName, lpDefault, lpReturnedString, nSize);
	};

	//! ڿ  Getϴ Լ.
	DWORD GetPrivateProfileString(
		LPCTSTR lpAppName,			// section name
		LPCTSTR lpKeyName,			// key name
		LPCTSTR lpDefault,			// default string
		LPTSTR	lpReturnedString,	// destination buffer
		DWORD	nSize				// size of destination buffer
		) const;

	//! ڿ  Getϴ Լ. CString  Է ޴´.
	DWORD GetString(
		LPCTSTR lpAppName,
		LPCTSTR lpKeyName,
		LPCTSTR lpDefault,
		CString &ReturnedString		//!< CString  Է.
		) const {
		return GetPrivateProfileString( lpAppName, lpKeyName, lpDefault, ReturnedString);
	};


	//! ڿ  Getϴ Լ. CString  Է ޴´.
	DWORD GetPrivateProfileString(
		LPCTSTR lpAppName,
		LPCTSTR lpKeyName,
		LPCTSTR lpDefault,
		CString &ReturnedString		//!< CString  Է.
		) const;

	//! ڿ  Getϴ Լ. CString ȯѴ.
	CString GetString(
		LPCTSTR lpAppName,
		LPCTSTR lpKeyName,
		LPCTSTR lpDefault
		) const {
		return GetPrivateProfileString( lpAppName, lpKeyName, lpDefault);
	};


	//! ڿ  Getϴ Լ. CString ȯѴ.
	CString GetPrivateProfileString(
		LPCTSTR lpAppName,
		LPCTSTR lpKeyName,
		LPCTSTR lpDefault
		) const;

	//! ڿ  Writeϴ Լ.
	BOOL WriteString(
		LPCTSTR lpAppName,			// section name
		LPCTSTR lpKeyName,			// key name
		LPCTSTR lpString			// string to add
		) const {
		return WritePrivateProfileString( lpAppName, lpKeyName, lpString);
	};


	//! ڿ  Writeϴ Լ.
	BOOL WritePrivateProfileString(
		LPCTSTR lpAppName,			// section name
		LPCTSTR lpKeyName,			// key name
		LPCTSTR lpString			// string to add
		) const;


	//! IP ּ Getϴ Լ.
	BOOL GetIpAddress(
		LPCTSTR lpAppName,
		LPCTSTR lpKeyName,
		LPCTSTR szDefault,			// "0.0.0.0"
		CIPAddressCtrl* ipAddress
		) {
		return GetPrivateProfileIpAddress( lpAppName, lpKeyName, szDefault, ipAddress);
	};

	/*!
	 * \warning GetPrivateProfileIpAddress()Լ const óϷ 
	 * ο Ŭ Ѵٰ   const  .\n
	 * WritePrivateProfileIpAddress()Լ CIPAddressCtrl Ķͷ
	 * Ѱٷ  CIPAddressCtrl Ŭ copy constructor 
	 * ʴ´ٰ ؼ ͷ Ķ͸ Ѱ.
	 */
	BOOL GetPrivateProfileIpAddress(
		LPCTSTR lpAppName,
		LPCTSTR lpKeyName,
		LPCTSTR szDefault,			// "0.0.0.0"
		CIPAddressCtrl* ipAddress
	);

	//! IP ּ Writeϴ Լ.
	BOOL WriteIpAddress(
		LPCTSTR lpAppName,
		LPCTSTR lpKeyName,
		CIPAddressCtrl *ipAddress
		) {
		return WritePrivateProfileIpAddress( lpAppName, lpKeyName, ipAddress);
	};


	//! IP ּ Writeϴ Լ.
	BOOL WritePrivateProfileIpAddress(
		LPCTSTR lpAppName,
		LPCTSTR lpKeyName,
		CIPAddressCtrl *ipAddress
	);

// Overrides
public:
	//! IPּ  String IPּ  ȯϴ Լ.
	void Str2IP( const TCHAR *inBuf, BYTE& b1, BYTE& b2, BYTE& b3, BYTE& b4);

	//! IPּ 鿡 IPּε ڿ ̾Ƴ Լ.
	void IP2Str( BYTE b1, BYTE b2, BYTE b3, BYTE b4, TCHAR *buf);

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCfgFile)
	//}}AFX_VIRTUAL

	// Generated message map functions
	//{{AFX_MSG(CCfgFile)
	// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	// Implementation
protected:
	CString m_szFileDir;		//!< File root directory.
	CString m_szFileName;		//!< File name.
	CString m_szFilePath;		//!< File Full Path.

	void SetIniFileInfo();		//!< exe  η ini θ .
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CFGFILE_H__8DB0FD51_61E5_11D6_80A9_000476D2B6CA__INCLUDED_)

/* vim:set ft=cpp ts=4 sw=4 sts=4 sta ai bs=2: */
