/* vim:set ft=cpp ts=4 sw=4 sts=4 sta ai: */
/* History
 * v0.1.000	[20040521]
 *  1. directory   ִ ̾α׸  Լ.
 */

#include "StdAfx.h"
#include "DirBrowser.h"


TCHAR g_sGetDirectoryDir[MAX_PATH];
static int CALLBACK BrowseCallbackProc(HWND hwnd,UINT msg,LPARAM lp, LPARAM pData)
{
	TCHAR buf[MAX_PATH];
	switch(msg) 
	{
	case BFFM_INITIALIZED: 
		_tcscpy(buf,g_sGetDirectoryDir);
		::SendMessage(hwnd,BFFM_SETSELECTION,TRUE,(LPARAM)buf);
		break;
	case BFFM_SELCHANGED:
		if (::SHGetPathFromIDList((LPITEMIDLIST) lp ,buf)) 
			SendMessage(hwnd,BFFM_SETSTATUSTEXT,0,(LPARAM)buf);
		break;
	}
	return 0;
}

#ifndef BIF_NEWDIALOGSTYLE
  #define BIF_NEWDIALOGSTYLE     0x0040   // Use the new dialog layout with the ability to resize
  #define BIF_USENEWUI           (BIF_NEWDIALOGSTYLE | BIF_EDITBOX)
#endif

LPCTSTR GetDirectory(HWND hWndParent, LPCTSTR szRoot, LPCTSTR szTitle)
{
	static TCHAR str[MAX_PATH];
	BROWSEINFO bi;
    bi.hwndOwner=hWndParent;		//owner of created dialog box
    bi.pidlRoot=0;					//unused
    bi.pszDisplayName=0;			//buffer to receive name displayed by folder (not a valid path)
    bi.lpszTitle=szTitle;			//title is "Browse for Folder", this is an instruction
	bi.lpfn = BrowseCallbackProc;	//callback routine called when dialog has been initialized
    bi.lParam=0;					//passed to callback routine
    bi.ulFlags=
		BIF_RETURNONLYFSDIRS |		//only allow user to select a directory
		BIF_STATUSTEXT |			//create status text field we will be writing to in callback
		BIF_NEWDIALOGSTYLE |		// resizing  ο Ÿ..OleInitialize()  ȣ Ǿ־ ..
//		BIF_BROWSEFORCOMPUTER|		//only allow user to select a computer
//		BIF_BROWSEFORPRINTER |		//only allow user to select a printer
//		BIF_BROWSEINCLUDEFILES|		//displays files too which user can pick
//		BIF_DONTGOBELOWDOMAIN|		//when user is exploring the "Entire Network" they
									// are not allowed into any domain
		0;
	if( szRoot == NULL) {
		g_sGetDirectoryDir[0] = '\0';
	} else {
		_tcscpy(g_sGetDirectoryDir, szRoot);
	}

	LPITEMIDLIST lpItemId=::SHBrowseForFolder(&bi); 
	if (lpItemId)
	{
		::SHGetPathFromIDList(lpItemId, str);
		::GlobalFree(lpItemId);
		return str;
	}

	return NULL;
}
